org 0x100

;Mov the global stack to 0x100, conflicts are happening
;As long as some one doesn't go 0x100 stack pushes

;Well, we're going to  try Flat Real Mode, i think i have this figured
;out.
;Nope, don't have it figured out, but i am going to  allocate 0x4000 bytes
;for stack space, but i'm not going to let it run straight into the program,
;so i'm limiting it to a lower limit of 0x300, some where well past the
;thread info.
mov   ax, ss
;shl   ax, 4
add   ax, 0x30
mov   ss, ax

mov   sp, 0x4000-0x300

;Set up the DServ Int 0xA8
mov   ax, 0x25A8
mov   dx, intA8
int   0x21

;Resize the Ram it requires (40 Para's)
mov   ah, 0x4A
push  cs
pop   es
mov   bx, 0x400
int   0x21

mov   ah, 0x62
int   0x21
mov   es, bx
mov   ax, word [es:0x16]
mov   [dodad], ax
mov   ax, word [es:0x0a]
mov   [dodad+2], ax
mov   ax, word [es:0x0c]
mov   [dodad+4], ax

;Load default Command (Bean?)
;mov  dx, default
;mov  bx, defauPar
;mov  ah, 0x01
;int  0xA8

;Add Thread Pointer
;mov  ah, 0x02
;int  0xA8

;Take the first key
;mov  ah, 0x10
;int  0x16

;Begin Thread Loop
main:
 cmp  word[current], 0
 jz   testStatus
 mov  di, [current]
 mov  es, [istseg+di]
 mov  bx, [istoff+di]
 mov  [jmppoint], bx
 mov  [jmppoint+2], es
 pushf
 call far[jmppoint]
jmpret:
 add  word[current], 0x04
 mov  ax, [current]
 cmp  ax, [max]
 jnz  main
testStatus:
 mov  word[current], 0
 cmp  byte[status], 0
 jz   main


;Exit code 0

;mov  ah, 0x62
;int  0x21
;mov  es, bx
;mov  ax, [dodad]
;mov  word [es:0x16], ax
;mov  ax, [dodad+2]
;mov  word [es:0x16], ax
;mov  ax, [dodad+4]
;mov  word [es:0x16], ax
;mov  ah, 0x50
;mov  bx, es
;int  21h
mov  ax, 0x4C00
int  0x21


;Int 0xA8 table
;Thanks to some ingenuity, i can now
;Easily update my int table with ease.
intA8:
 cmp  ah, 7
 jg   noSubFunc
 push bx
 mov  bx, A8jmp
 shl  ah, 2
 add  bl, ah
 jmp  bx
noSubFunc
 mov  ax, 0xFFFE
 iret

A8jmp:
 nop
 nop
 nop
 nop
 pop  bx
 jmp  AH01
 pop  bx
 jmp  AH02
 pop  bx
 jmp  AH03
 pop  bx
 jmp  AH04
 pop  bx
 jmp  AH05
 pop  bx
 jmp  AH06
 pop  bx
 jmp  AH07

AH01:
 ;ah=0x01: load thread program
 ;ds:dx = command+path
 ;es:bx = command tail (command line parameters)
 ;push  es
 push  ds
 mov   [cs:stac], sp
 mov   [cs:stac+2], ss
 mov   word [cs:param+4], es
 mov   [cs:param+2], bx
 mov   bx, param
 push  cs
 pop   es
 mov   ax, 0x4B00
 mov   cx, 0
 int   0x21
 mov   sp, [cs:stac]
 mov   ss, [cs:stac+2]
 pop   ds
 ;pop   es
 jmp   end
 param dw  0000, 0000, 0000, 0000, 0000

AH02:
 ;ah=0x02: Add new thread from int 0xA9
 ;no special parameters
 push di
 push ds

 push cs
 pop  ds
 mov  ax, 0x35A9
 int  0x21
 mov  di, [max]
 mov  ax, es
 cmp  ax, 0
 jz   AH021
 mov  [istseg+di], ax
 mov  [istseg+2+di], bx
 add  di, 0x04
 mov  [max], di
 push  ds
 mov   ax, 0
 mov   ds, ax
 mov   dx, 0
 mov   ax, 0x25A9
 int   0x21
 pop   ds
AH021:
 pop  ds
 pop  di
 jmp  end

AH03:
 ;ah=0x03: Add new thread
 ;es:bx = new thread address
 push di
 push ds

 push cs
 pop  ds
 mov  di, [max]
 mov  ax, es
 mov  [istseg+di], ax
 mov  [istoff+di], bx
 add  di, 0x04
 mov  [max], di
 pop  ds
 pop  di
 jmp  end

AH04:
 ;ah=0x04: Remove Thread
 ;es:bx = thread to terminate
 push cs
 pop  ds
 mov  di, 0x0000-0x04
 mov  cx, es
AH041:
 add  di, 0x04
 cmp  cx, [istseg+di]
 je   AH042
 cmp  di, [max]
 je   AH043
 jmp  AH041
AH042:
 cmp  bx, [istoff+di]
 jne  AH041
 sub  word [max], 0x04
 mov  si, [max]
 cmp  di, si
 je   AH044
 mov  ax, [istseg+si]
 mov  [istseg+di], ax
 mov  ax, [istoff+di]
 mov  [istoff+di], ax
AH044:
 mov  ax, 0x0000
 mov  [current], ax
 jmp  end

AH043:
 mov  ax, 0xFF00
 jmp  end

AH05SEG  dw 0x0000

AH05:
 ;ah=0x05: Soft Terminate Program
 ;es = PSP Segment
 push cs
 pop  es
 mov  bx, DieRet
 iret
DieRet:
 push cs
 pop  ss
 mov  sp, 0x100
 jmp  jmpret
 
AH06:
 ;ah = 06: Terminate DServ
 ;No parameters
 push ds
 push cs
 pop  ds
 mov  byte[status], 0x01
 pop  ds
 jmp  end

AH07:
 ;Hard (prefered) Terminate Program
 ;es=PSP to terminate.
 ;Make sure to remove ALL running threads first!
 push cs
 pop  ax
 mov  bx, AH07Ret
 mov  word [es:0x16], ax
 mov  word [es:0x0A], bx
 mov  word [es:0x0C], ax
 mov  bx, es
 mov  ah, 50h
 int  21h
 mov  ax, 0x4C00
 int  0x21
AH07Ret:
 push cs
 pop  ss
 mov  sp, 0x100
 jmp  jmpret


end:
iret

;Global Data
stac     dw  0x0000, 0x0000
dodad    dw  0x0, 0x0, 0x0
default  db  'c:\dserv\bean\bean.com$'
defauPar db  0x00, 0x00
jmppoint dw  0000, 0000
status   db  0
current  dw  0000
max      dw  0000
istseg   dw  0000
istoff   dw  0000
