(* DWINDRAW.PAS: Please read the bottom of DWIN.PAS for Copyright details. *)

procedure draw.swich;
begin
end;

procedure draw.drawAbout;
var tey, tex: integer;
 winDumm: PWins;
 x, y, x1, y1: word;
 sil: skel;
begin
 checkDS(true);
{ mbusy := true;}
 sil.x := round(getMaxX/2)-75; sil.w := 150;
 sil.y := round(getMaxY/2)-50; sil.h := 100;
 VSkin.drawskin(sil);
 x := return.x; x1 := return.x+return.w;
 y := return.y; y1 := return.y+return.h;
 winDummy := VDesk.insert(x,y,x1,y1, 0, VMenu.stdMenu, 'About');
 VSkin.makeIcons(winDummy, 'DWin Enviroment');
 VDesk.repic(x, y, x1, y1,  winDummy);
 tex := round(getMaxX/2);
 tey := round(getMaxY/2)-40;
 say(tex, tey, 'DWIN Enviroment', centerAlign);
 tey := tey+9; say(tex, tey, 'Build #'+build, centerAlign);
 tey := tey+9; say(tex, tey, 'Version: '+version, centerAlign);
 tey := tey+9; say(tex, tey, 'By Jon Gentle', centerAlign);
 tey := tey+9; say(tex, tey, 'Copyright 1999,', centerAlign);
 tey := tey+9; say(tex, tey, '2000. All rights', centerAlign);
 tey := tey+9; say(tex, tey, 'Reserved.', centerAlign);
 buttn(tex-60, tey+16, 50, 10, 'Okay', winClose, winDummy, '');
 buttn(tex+5, tey+16, 50, 10, 'More', winClose, winDummy, '');
{ mbusy := false;}
 checkDS(false);
end;

procedure draw.drawBox(x, y, x1, y1: integer);
var i: integer;
begin
  sil.x := x; sil.w := x1-x;
  sil.y := y; sil.h := y1-y;
{  mbusy := true;}
  VSkin.drawskin(sil);
{  mbusy  := false;}
end;

procedure draw.say(x, y: integer; what: string; align: byte);
begin
 case align of
  centerAlign:
  begin
   if trunc((length(what)*4)/2) = round((length(what)*4)/2) then
    x := x-round((length(what)*8)/2)
   else
    x := x-round((length(what)*8)/2)-2;
  end;
 end;
 outTextXY(x, y, what);
end;

procedure draw.box(x, y, x1, y1: integer);
var mingle: array[1..4,0..1] of integer;
begin
 setFillStyle(1, getColor);
 mingle[1,0] := (x); mingle[1,1] := (y);
 mingle[2,0] := (x1); mingle[2,1] := (y);
 mingle[3,0] := (x1); mingle[3,1] := (y1);
 mingle[4,0] := (x); mingle[4,1] := (y1);
 FillPoly(4, mingle);
end;

procedure draw.buttn(x, y, h, w: integer; msg: string; cmd: word; winDu: PWins; extra: string);
var sil: skel;
begin
 sil.x := x; sil.y := y;
 sil.w := h; sil.h := w;
 VSkin.drawBttn(sil);
 say(trunc((h/2)+x), y+2, msg, centerAlign);
 if cmd <> winSay then begin
  if winDu = winMom then
  VWins.makeIcon(return.x, return.y, return.x+return.w, return.y+return.h, cmd, extra, winDu)
  else
   VHots.quilifyHotSpot(return.x, return.y, return.x+return.w, return.y+return.h, cmd, extra, winDu);
  if repic = true then
   VDesk.repic(winDu^.priv.x, winDu^.priv.y, winDu^.priv.x+winDu^.priv.w, winDu^.priv.y+winDu^.priv.h, winDu);
 end;
end;

procedure draw.rebuttn(midx, midy, h, w: integer; cmd: word; winDu: PHots; msg: string);
begin
 setcolor(15);
 line(midx-h-2, midy-w-2, midx+h+2, midy-w-2);
 line(midx-h-1, midy-w-1, midx+h+1, midy-w-1);
 line(midx-h-2, midy-w-2, midx-h-2, midy+w+2);
 line(midx-h-1, midy-w-1, midx-h-1, midy+w+1);
 setcolor(7);
 line(midx-h-2, midy+w+2, midx+h+2, midy+w+2);
 line(midx-h-1, midy+w+1, midx+h+1, midy+w+1);
 line(midx+h+2, midy-w-2, midx+h+2, midy+w+2);
 line(midx+h+1, midy-w-1, midx+h+1, midy+w+1);
 setcolor(1);
 box(midx-h, midy-w, midx+h, midy+w);
 setcolor(15);
 say(midx, midy-3, msg, centerAlign);
end;

procedure draw.drawHotSpots;
var tee: PHots;
tale: PWins;
begin
 tale := winMom;
 setColor(15);
 while tale <> nil do
 begin
  tee := tale^.spotMom;
  while tee <> nil do with tee^ do
  begin
   box(xTpos, yTpos, xBpos, yBpos);
   tee := tee^.nextHot;
  end;
 tale := tale^.nextWin;
 end;
end;
