(* SKNPARSE.PAS: Please read the bottom of this program for Copyright details. *)

uses strings;
var f: text;
 outf: file;
 lineRead: string;
 pos: integer;
 curr: integer;
 valI, code: integer;
 temStr, dodad, ddd: array[0..255] of char;
 v, vv: boolean;
 d: byte;

procedure version;
begin
 writeln('');
 writeln('(* ************************************************************ *)');
 writeln('(* Copyright (c) 1999-2000 Jon Gentle, All right reserved.      *)');
 writeln('(* ************************************************************ *)');
 writeln('(* This software is given As-Is.  No warranties of any kind,    *)');
 writeln('(* implied or expressed, are given to anyone.  The author(s)    *)');
 writeln('(* shall not be held for any liability under any circumstances. *)');
 writeln('(* Permission is granted to anyone who wishes to alter, use or  *)');
 writeln('(* distribute this software, as long as the following           *)');
 writeln('(* restrictions are met:                                        *)');
 writeln('(*                                                              *)');
 writeln('(* 1) The above copyright and this notice must appear in the    *)');
 writeln('(* software, both in binary and source code form.  Under no     *)');
 writeln('(* circumstance are these to be removed.                        *)');
 writeln('(* 2) Anyone other then the copyright owner that alters source  *)');
 writeln('(* code must mark the source code as altered.                   *)');
 writeln('(* 3) Original authorship of part or whole must not be          *)');
 writeln('(* misrepresented.                                              *)');
 writeln('(* ************************************************************ *)');
 halt(0);
end;

procedure makeImage;
var i, a, b, c, o, u, uu: integer;
  stri: string;
  working, doop: word;
  w, h: byte;
  waitWrite: array[0..256] of byte;
  block: word;
begin
 readln(f, stri);
 block := 5; h := 0; w := 0;
 while stri <> '<HRBG>' do
 begin
  h := h + 1;
  i := 1; while ((stri[i] <> ' ') AND (i <= length(stri))) do i := i+1; w := i-1;
  i := 1; o := 1; u := 0; uu := 0; b := 0; c := 0;
  i := 1; o := 1; u := 0;
  while i <= length(stri) do
  begin
   while ((stri[i] <> ' ') AND (i <= length(stri))) do i := i+1;
   u := i;
   while u-o > 0 do
   begin
    doop := 128; working := 0;
    if u-o > 7 then uu := o+7 else uu := u-1;
    for a :=  o to uu do
    begin
     if stri[a] = '1' then working := working + doop;
     doop := doop shr 1;
    end;
    waitWrite[block] := working;
    block := block+1; o := o+8;
   end;
    i := i+1;
    o := i;
  end;
  readln(f, stri);
 end;
 if h > 0 then h := h - 1;
 if w > 0 then w := w - 1;

 waitWrite[0] := block-1;
 waitWrite[1] := w;
 waitWrite[2] := 0;
 waitWrite[3] := h;
 waitWrite[4] := 0;
 for a := 0 to block-1 do blockwrite(outf, waitWrite[a], 1);
end;

function strFind(stri:  string; search: string): integer;
var i, a: integer;
 start: integer;
begin
 i := curr;
 start := curr;
 while ((stri[i] <> search) AND (i <= length(stri))) do i := i+1;
 for a := start to i do
  temStr[a-start] := stri[a];
 temStr[i-start] := #0;
 val(temStr, valI, code);
 curr := i+1;
 strFind := vali;
end;

begin
 d := 1;
 if ((paramstr(1) = '') OR (paramstr(1) = '-h') OR (paramstr(1) = '/?') OR (paramstr(1) = '--help')) then
 begin
  halt(0);
 end;
 if ((paramstr(1) = '-l') OR (paramstr(1) = '/l')) then version;
 if paramstr(1) = '/n' then begin v := true; d := 2; end else v := false;
 if paramstr(1) = '/vn' then begin v := true; vv :=  true; d := 2; end else vv := false;
 assign(f, paramstr(d)); d:= d+1;
 if paramstr(d) <> '' then assign(outf, paramstr(d)) else assign(outf, 'defunk.skn');
 reset(f);
 writeln('Opened '+paramstr(d-1)+' for input...');
 filemode := 1;
 rewrite(outf, 1);
 readln(f, lineRead);
 write('Skin.......');
 if (v) then writeln('');
 while lineRead <> '<Bitmap>' do
 begin
  if ((lineRead[1] <> '#')  AND (lineRead <> '')) then
  begin
   if (lineRead = '[Spacing]') then
   begin
    if(v) then write('Spaceing...');
    readln(f, lineRead);
    curr := 1;
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    if(v) then writeln('done');
   end;
   if (lineRead = '[BGColor]') then
   begin
    if(v) then write('BGcolor....');
    readln(f, lineRead);
    val(lineRead, valI, code);
    blockwrite(outf, valI, 1);
    if(v) then writeln('done');
   end;
   if (lineRead = '[Coor]') then
   begin
    if(v) then write('Coor.......');
    readln(f, lineRead);
    curr := 1;
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    if(v) then writeln('done');
   end;
   if (lineRead = '[HRBG]') then
   begin
    if(v) then write('Img Map....');
    makeImage;
    if(v) then writeln('done');
   end;
  end;
  readln(f, lineRead);
 end;
 writeln('done');
 valI := 0;
 blockwrite(outf, valI, 9);
 write('Button.....');
 if (v) then writeln('');
 while lineRead <> '<Button>' do
 begin
  if ((lineRead[1] <> '#')  AND (lineRead <> '')) then
  begin
   if (lineRead = '[Spacing]') then
   begin
    if(v) then write('Spaceing...');
    readln(f, lineRead);
    curr := 1;
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 1);
    if(v) then writeln('done');
   end;
   if (lineRead = '[BGColor]') then
   begin
    if(v) then write('BGcolor....');
    readln(f, lineRead);
    val(lineRead, valI, code);
    blockwrite(outf, valI, 1);
    if(v) then writeln('done');
   end;
   if (lineRead = '[Coor]') then
   begin
    if(v) then write('Coor.......');
    readln(f, lineRead);
    curr := 1;
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    if(v) then writeln('done');
   end;
   if (lineRead = '[HRBG]') then
   begin
    if(v) then write('Img Map....');
    makeImage;
    if(v) then writeln('done');
   end;
  end;
  readln(f, lineRead);
 end;
 writeln('done');
 valI := 0;
 blockwrite(outf, valI, 9);
 write('Mouse......');
 if (v) then writeln('');
 while lineRead <> '<Mouse>' do
 begin
  if ((lineRead[1] <> '#')  AND (lineRead <> '')) then
  begin
   if (lineRead = '[Coor]') then
   begin
    if(v) then write('Coor.......');
    readln(f, lineRead);
    curr := 1;
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    if(v) then writeln('done');
   end;
   if (lineRead = '[HRBG]') then
   begin
    if(v) then write('Img Map....');
    makeImage;
    if(v) then writeln('done');
   end;
  end;
  readln(f, lineRead);
 end;
 writeln('done');
 write('Icons......');
 if (v) then writeln('');
 while lineRead <> '<Icon>' do
 begin
  if ((lineRead[1] <> '#')  AND (lineRead <> '')) then
  begin
   if (lineRead = '[Coor]') then
   begin
    if(v) then write('Coor.......');
    readln(f, lineRead);
    curr := 1;
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    valI := strFind(lineRead, ',');
    blockwrite(outf, valI, 2);
    if(v) then writeln('done');
   end;
   if (lineRead = '[HRBG]') then
   begin
    if(v) then write('Img Map....');
    makeImage;
    if(v) then writeln('done');
   end;
   if (lineRead = '[Command]') then
   begin
    if(v) then write('Command....');
    readln(f, lineRead);
    val(lineRead, valI, code);
    blockwrite(outf, valI, 2);
    if(v) then writeln('done');
   end;
  end;
  readln(f, lineRead);
 end;
 writeln('done');
 valI := 0;
 blockwrite(outf, valI, 11);
 close(outf);
 writeln('Closed ' + paramstr(d-1) + ' for skinning.');
end.

(* ************************************************************ *)
(* Copyright (c) 1999-2000 Jon Gentle, All right reserved.      *)
(* ************************************************************ *)
(* This software is given As-Is.  No warranties of any kind,    *)
(* implied or expressed, are given to anyone.  The author(s)    *)
(* shall not be held for any liability under any circumstances. *)
(* Permission is granted to anyone who wishes to alter, use or  *)
(* distribute this software, as long as the following           *)
(* restrictions are met:                                        *)
(*                                                              *)
(* 1) The above copyright and this notice must appear in the    *)
(* software, both in binary and source code form.  Under no     *)
(* circumstance are these to be removed.                        *)
(* 2) Anyone other then the copyright owner that alters source  *)
(* code must mark the source code as altered.                   *)
(* 3) Original authorship of part or whole must not be          *)
(* misrepresented.                                              *)
(* ************************************************************ *)

